/**
 * \file felhfelulet.h
 *
 * A felhasználói felületet megvalósító osztályok definiciói
 * Nem ismeri a modellt.
 *
 */
#ifndef FELULET_H
#define FELULET_H
#include <iostream>
#include <boost/signals2.hpp>

/// Gomb.
/// A gomb "megnyomására" meghívódik a nnyom() tagfüggvény
class Gomb {
    boost::signals2::signal<void ()> sig;
public:
    template <typename F>
    Gomb(F f) {
	 sig.connect(f); 
    }

    /// A felhasználó felületen megnyomták a gombot
    void nyom() {               // megnyomták
	sig();
    }
};
#endif // FELULET_H
