/**
 * Felhasználói felület és a modell kapcsolata
 * Callback fv. demó
 *
 */
#include <iostream>
#include "modell.h"
#include "felhfelulet.h"
#include <boost/signals2.hpp>
#include <boost/bind.hpp>

using std::cout;
using std::endl;
using std::cin;

int main() {
    Kapcsolo k1("k1");
    Gomb g1(boost::bind(&Kapcsolo::callBack, &k1));    // itt kötjük össze  a felhasználói felületet és a modellt.

    cout << "Megyomjuk a gombot: " << endl;
    cin.ignore(100, '\n');
    g1.nyom();      // felületen megnyomták
    cout << "Megint megyomjuk a gombot: " << endl;
    cin.ignore(100, '\n');
    g1.nyom();      // újra
    cout << "Ismet megyomjuk a gombot: " << endl;
    cin.ignore(100, '\n');
    g1.nyom();      // újra
    cout << "Ismet megyomjuk a gombot: " << endl;
    cin.ignore(100, '\n');
    g1.nyom();      // újra


/// Eddig nem sokban különbözött, csupán nem kellett e callback osztály. 
/// De sokkal rugalmasabb. Csupán egy példa: 

    std::cout << "\nMindent elpszor be-, majd kikapcsol.\n";
    Kapcsolo k2("k2");
    boost::signals2::signal<void ()> beki;
    beki.connect(0, boost::bind(&Kapcsolo::be, &k1));
    beki.connect(1, boost::bind(&Kapcsolo::ki, &k1));
    beki.connect(1, boost::bind(&Kapcsolo::ki, &k2));
    beki.connect(0, boost::bind(&Kapcsolo::be, &k2));

    beki();
    return 0;
}
